// Some functions to use
void fn1() {}
void fn2(const int) {}
int fn3() { return 0; }
void* fn4() { return (void*)0; }

/**
* \brief Test class containing methods which contain function pointers.
*/
class A {
  public:
    A() {}
    virtual ~A() {}

    /**
    * \brief Test function using function pointer parameter to fn1.
    *
    * \param fn1 Function pointer to fn1().
    */
    void do_fn1(void (fn1)()) { fn1(); }

    /**
    * \brief Test function using function pointer parameter to fn2.
    *
    * \param fn1 Function pointer to fn2().
    */
    void do_fn2(void (fn2)(const int)) { fn2(0); }

    /**
    * \brief Test function using function pointer parameter to fn3.
    *
    * \param fn1 Function pointer to fn3().
    */
    void do_fn3(int (fn3)()) { fn3(); }

    /**
    * \brief Test function using function pointer parameter to fn4.
    *
    * \param fn1 Function pointer to fn4().
    */
    void do_fn4(void* (fn4)()) { fn4(); }
};

int main (int argc, char** argv) {
    A a;
    a.do_fn1(&fn1);
    a.do_fn2(&fn2);
    a.do_fn3(&fn3);
    a.do_fn4(&fn4);
}

